clc; clear all; close all;

% Vstupni tenzory pro MAX, extrapoluji do nuly
T2 = [20.8 -2.5015 27.295; %bod A
      -2.5015  122.19 -3.2814;
      27.295 -3.2814 35.835]; 
  
T1 = [21.369 -1.9725 30.423; %bod B
      -1.9725  107.84 -2.8063;
      30.423 -2.8063 43.32];
% Tloustka
t = 26;
% Vstupni data: body pro interpolaci
x1 = 0.4 * t;
x2 = 0.6 * t;
x = [x1,x1+x2];

for i = 1:numel(T1)    
    %figure(i)
    %hold on    
    % ---Hodnoty x a y v bodech pro interpolaci---
    y = [T1(i) T2(i)];
    % Interpoluj, polynom prvniho stupne
    polynom = polyfit(x,y,1);
    
    % ---Nove body pro extrapolaci---
    x_ext = [0 x];
    % Nove funkcni hodnoty na zaklade polynomu
    y_ext = polyval(polynom, x_ext);
    %plot(x_ext, y_ext,'o');
    %    grid on
    % ---Zobraz cely polynom---
    x_pol = [0:0.1:max(x_ext)];
    y_pol = polyval(polynom, x_pol);    
    %plot(x_pol, y_pol,'r');
    %    grid on
    % ---Ulozit extrapolovana data do tenzoru--
    T3(i) = y_ext(1);    
end

EXT = reshape(T3, [3,3])
 
[V1,D]=eig(EXT)
sigma_1=max(diag(D));
sigma_3=min(diag(D));
sigma_red=sigma_1-sigma_3;
delta_sigma_red = sigma_red * 1/6
disp('----------------------------------') % kapitola 18.6
disp('Redukovan napt:')
disp(sigma_red)
disp('Redukovan rozkmit Delta Sigma_eq:')
disp(delta_sigma_red)
disp('----------------------------------')
%% kapitola 18.8 Elastoplastick podmnky
% delta_Sigma_eq > 2*Rp_02 -> pokud plat, mus bt rozkmit nsoben
% plastickm koreknm souinitelem Ke(mechanick zaten) -> NEPLAT
% tab. 18-4 c) Detail . 3.2 Pechod housenky svaru do skoepiny,pln
% provaeno, Svarov koef. z = 0,85 => tda 63 (zkuebn skupina 3)
%% kapitola 18.10 navov pevnost svaovanch detail
% uvaovan tloutka materilu e_n = 26 mm => f_ew = (25/e_n)^0.25
% dle (18.10.6.1)
e_n = 26; % mm
f_ew = (25/e_n)^0.25 % korekn souninitel zvisl na tlouce u svaovanch komponent a roub
f_t = 1 % korekn souninitel zvisl na teplot, jestlie T < 100C => f_t = 1
f_w = f_ew * f_t % Celkov korekn souinitel pro svaovan komponenty

% 18.10.7 navov kivky
%------------------------------------------------------------------------------
% Pro navovou ivotnost do 5e6 cykl a pro ivotnost nad 5e6 cykl plat
% rzn hodnoty. pro zaten konstantn amplitudou odpovd mez navy
% delta_sigma_d rozkmitu napr pro 5e6 cykl. Pro promnnou amplitudu
% zaten je prahovou mez delta_sigma_cut hodnota 1e8 cykl. Hodnoty pro
% dan meze jsou uvedeny v tabulce 18-7.
%------------------------------------------------------------------------------
% tab 18-7 - Souinitele navovch kivek pro svaovan komponenty, tda 63:
% delta_sigma_d = 46 MPa (pro N = 5e6); delta_sigma_cut = 26 MPa (pro N = 10e7) 
ratio = delta_sigma_red/f_w
delta_sigma_d = 46 %MPa
delta_sigma_cut = 26 %MPa
m1 = 3;
C1 = 5e11;
m2 = 5;
C2 = 1.08e15;

if ratio >= delta_sigma_d
    
            N = C1/(ratio^m1)
            
    elseif delta_sigma_cut < ratio < delta_sigma_d
        disp('-------------------------------------------------------------------------')
        disp('delta_sigma_cut < ratio < delta_sigma_d')
        disp('v ppad, e jsou vechny aplikovan rozkmity men ne delta_sigma_d, pak N = nekoneno')
            %N = C2/(ratio^m2)
          
            ratio
    elseif ratio <= delta_sigma_cut
        
            disp('N = neverending story')
    
end
    