clc; clear all; close all;

% Vstupni tenzory pro MAX, extrapoluji do nuly
T2 = [1.1601e-002 -8.8572e-002 -2.1785e-004; %bod A
      -8.8572e-002  -119.76 -0.21389;
      -2.1785e-004 -0.21389 43.178]; 
  
T1 = [2.2787e-002 -0.11361 4.2883e-003; %bod B
      -0.11361  -131.12 0.17298;
      4.2883e-003 0.17298 95.632];
% Tloustka
t = 26;
% Vstupni data: body pro interpolaci
x1 = 0.4 * t;
x2 = 0.6 * t;
x = [x1,x1+x2];

for i = 1:numel(T1)    
    %figure(i)
    %hold on    
    % ---Hodnoty x a y v bodech pro interpolaci---
    y = [T1(i) T2(i)];
    % Interpoluj, polynom prvniho stupne
    polynom = polyfit(x,y,1);
    
    % ---Nove body pro extrapolaci---
    x_ext = [0 x];
    % Nove funkcni hodnoty na zaklade polynomu
    y_ext = polyval(polynom, x_ext);
    %plot(x_ext, y_ext,'o');
    %    grid on
    % ---Zobraz cely polynom---
    x_pol = [0:0.1:max(x_ext)];
    y_pol = polyval(polynom, x_pol);    
    %plot(x_pol, y_pol,'r');
    %    grid on
    % ---Ulozit extrapolovana data do tenzoru--
    T3(i) = y_ext(1);    
end

EXT = reshape(T3, [3,3])
 
[V1,D]=eig(EXT)
 sigma_1=max(diag(D));
 sigma_3=min(diag(D));
 delta_sigma_red=sigma_1-sigma_3;
 disp('----------------------------------') % kapitola 18.6
  disp('Redukovan extrapolovan napt Sigma_eq:')
 disp(delta_sigma_red)
 disp('Redukovan rozkmit Delta Sigma_eq:')
 disp(delta_sigma_red*1/6)
