clc; clear all; close all;
% Poradi bodu, zkontrolovat!
strings = ["B","A"];
% Pozice v tenzoru napeti
comps = ["X"  "XY" "XZ";
         "XY" "Y"  "YZ"; 
         "XZ" "YZ" "Z"];
% Cesty k souboru
base_path = "Point_";
base_ext = "exp_";
% Tloustka
t = 26;
% Vstupni data: body pro interpolaci
x1 = 0.4 * t;
x2 = 0.6 * t;
x = [x1,x1+x2];
% Pocet bodu na kruznici
num_elem = 241;
% Stupen polynomu
poly_dgr = 1;
% Prealokace pole pro tenzory
tensors{length(strings),num_elem} = [];
for i = 1:size(tensors,1)
    for j = 1:size(tensors,2)
        tensors{i,j} = zeros(3,3);
    end
end
% Projed body BA
for i = 1:numel(strings)
    % Prealokace
    tens = zeros(3,3);
    % Projed cely tensor, zbytecne, ale funguje...
    for j = 1:3
        for k = 1:3
            path = strcat(base_path,strings(i),"\",base_ext,strings(i),"_",comps(j,k),".txt");
            num = readmatrix(path);           
            nap = num(:,5);  
            for b = 1:num_elem
                tensors{i,b}(j,k) = nap(b);
            end
        end
    end
end
% Vynasobeni 1/6
for i = 1:size(tensors,1)
    for j = 1:size(tensors,2)
        tensors{i,j} = tensors{i,j} * (1/6);
    end
end
% Prealokace
results{1,num_elem} = [];
for i = 1:size(results,2)
    results{i} = zeros(3,3);    
end
% Spocitej odpovidajici tenzory v bode 0 
for i = 1:num_elem
   T = tensors(:,i);   
   results{i} = ext_nula(T,x,poly_dgr);
end
% Redukovane napeti
ds_result = zeros(1,num_elem);
for i = 1:num_elem
     [V1,D]=eig(results{i});
     sigma_1=max(diag(D));
     sigma_3=min(diag(D));
     ds_result(i)=sigma_1-sigma_3;      
end
n = 3;
ds_result_sub = maxk(ds_result,n)
% Najdi indexy
ind = zeros(1,n);
for i = 1:n
    ind(i) = find(ds_result==ds_result_sub(i));
end

% Vypocitej redukovane napeti v odpovidajicich tenzorech
% Redukovane napeti
ds_other = zeros(size(tensors,1),n);
for i = 1:n
    for j = 1:size(tensors,1)
        [V1,D]=eig(tensors{j,ind(i)});
        sigma_1=max(diag(D));
        sigma_3=min(diag(D));
        ds_other(j,i)=sigma_1-sigma_3;  
    end
end
ds_final = [ds_result_sub;
            ds_other];
x_ext = [0 x];
for i = 1:n
    figure(i)
    hold on  
    polynom = polyfit(x_ext,ds_final(:,i)',poly_dgr);
    % Funkcni hodnoty
    plot(x_ext, ds_final(:,i)','o');
        grid on
    % ---Zobraz cely polynom---
    x_ext_poly = x_ext(1):0.01:x_ext(end);
    y_ext_poly = polyval(polynom, x_ext_poly);    
    plot(x_ext_poly, y_ext_poly,'r');
        grid on
end
