clc; clear all; close all;

% Vstupni tenzory
T3 = [26.556 -1.777 -28.416; %bod A
      -1.777  148.07 1.9356;
      -28.416 1.9356 29.244];
  
T2 = [24.103 -1.91 -27.878; %bod B
      -1.91  144.4 2.2111;
      -27.878 2.2111 32.198];
  
T1 = [19.767 -2.1807 -25.423; %bod C
      -2.1807  123.43 2.763;
      -25.423 2.763 33.035];
% Tloustka
t = 26;
% Vstupni data: body pro interpolaci
x1 = 0.5 * t;
x2 = 1 * t;
x3 = 1 * t;
x = [x1,x1+x2,x1+x2+x3];

for i = 1:numel(T1)    
    %figure(i)
    %hold on    
    % ---Hodnoty x a y v bodech pro interpolaci---
    y = [T1(i) T2(i) T3(i)];
    % Interpoluj, polynom druheho stupne
    polynom = polyfit(x,y,2);
    
    % ---Nove body pro extrapolaci---
    x_ext = [0 x];
    % Nove funkcni hodnoty na zaklade polynomu
    y_ext = polyval(polynom, x_ext);
    %plot(x_ext, y_ext,'o');
        grid on
    % ---Zobraz cely polynom---
    x_pol = [0:0.1:max(x_ext)];
    y_pol = polyval(polynom, x_pol);    
    %plot(x_pol, y_pol,'r');
        %grid on
    % ---Ulozit extrapolovana data do tenzoru--
    T4(i) = y_ext(1);    
end

EXT = reshape(T4, [3,3]);

tensors = {EXT T1 T2 T3};
napeti_red = zeros(1,4);
for k = 1:numel(tensors)
    [V1,D] = eig(tensors{k});
    sigma_1 = max(diag(D));
    sigma_3 = min(diag(D));
    sigma_red = sigma_1 - sigma_3;
    delta_sigma_red = sigma_red * 1/6;
    napeti_red(k) = delta_sigma_red;
end

polynom = polyfit(x_ext,napeti_red,2);  
% Nove funkcni hodnoty na zaklade polynomu
x_pol = [0:0.1:max(x_ext)];
y_pol = polyval(polynom, x_pol);
hold on
plot(x_ext, napeti_red,'o');   
plot(x_pol, y_pol,'r');


 disp('----------------------------------') % kapitola 18.6
 % disp('Redukovan extrapolovan napt Sigma_eq:')
 %disp(delta_sigma_red)
 disp('Redukovan rozkmit Delta Sigma_eq:')
 disp(napeti_red(1))